
/*
 *
 * Copyright (c) 2006-2007 Solexa
 * Author: Klaus Maisinger
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 *
 */

//
// CVS - $Id: BaseCallParamsXMLReader.cpp,v 1.1 2007/01/25 13:39:44 lm Exp $
//

#include <cstdlib>
#include <cstring>

#include "BaseCallParamsXMLReader.h"

BaseCallParamsXMLReader::BaseCallParamsXMLReader()
{
    inParameters = 0;
    inPhasing = inPrephasing = 0;
}

BaseCallParamsXMLReader::~BaseCallParamsXMLReader()
{
}

void BaseCallParamsXMLReader::startDocument()
{
    phasing = 0.;
    prephasing = 0.;
}

void BaseCallParamsXMLReader::startElement(const char name[])
{
    if (!strcmp(name, "Parameters"))
        inParameters = 1;
    if (!strcmp(name, "Phasing"))
        inPhasing = 1;
    if (!strcmp(name, "Prephasing"))
        inPrephasing = 1;
}        

void BaseCallParamsXMLReader::endElement(const char name[])
{
    if (!strcmp(name, "Parameters"))
        inParameters = 0;
    if (!strcmp(name, "Phasing"))
        inPhasing = 0;
    if (!strcmp(name, "Prephasing"))
        inPrephasing = 0;
}        

void BaseCallParamsXMLReader::characters(const char ch[], int start, int length)
{
    if (!inParameters)
        return;
    if (inPhasing)
        phasing = atof(ch);
    if (inPrephasing)
        prephasing = atof(ch);
}
