/*
 *
 * Copyright (c) 2004-2007 Solexa Ltd.
 * Author: Klaus Maisinger
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 *
 */

/*  Time-stamp: <26 Jun 2006 17:04 BST DNAProcess.h km> */

#ifndef _DNAPROCESS_H
#define _DNAPROCESS_H

#include "Positions.h"

void read_sequence_file(const char filename[],
                        unsigned char *sequence_array,
                        int nobj, int ncycle);
void write_quality_file(const char filename[], float *prob,
                        int nobj, int nprob, int ncol);

int write_sequence_file(const char filename[],
                        unsigned char *sequence_array,
                        int nobj, int ncycle,
                        int lane = 0, int tile = 0, st_fposition *positions = 0);
int write_quality_file(const char filename[], std::vector<float * > prob,
                       int nobj, int ncol);

void rescale_intensities(float *intensities, float *rescaled_intensities,
                         int nobj, int ncol, float *matrix);
void call_bases(float *intensity, float *sigma, int nmol, int ncol,
                unsigned char *bases, unsigned char *sequence);

#endif /* _DNAPROCESS_H */
