/*
 * Main program for per-cycle intensity correlation calculation.
 * 
 * Copyright (c) Solexa 2005, 2006
 * Author: Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */

/*
 * Utility to estimate average phasing and prephasing rates as a
 * linear regression of the average correlation between the signal
 * in different cycles.
 */
 
#include <cstdio>
#include <cstdlib>
 
int main(int argc, char *argv[]) 
{
    char phasing_filename[FILENAME_MAX] = "";
    
    if (argc != 1) {
        fprintf(stderr,  "Usage: PhasingSummary < phasing file>\n");
        exit(1);
    }
    else {
         snprintf(phasing_filename, FILENAME_MAX, "%s", argv[0]);
    }
    
    return 0;
}
