/*
 *
 * Copyright (c) 2006-2007 Solexa
 * Authors: Klaus Maisinger, Lorenzo Milazzo
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 *
 */

//
// CVS - $Id: PhasingModel.h,v 1.2 2007/03/29 13:51:57 km Exp $
//

#ifndef _PHASINGMODEL_H
#define _PHASINGMODEL_H

#include <vector>

class PhasingWindow
{
public:
    float value;
    int   cycle;
    PhasingWindow() { value = 0.; cycle = 0; }
};

class PhasingModel
{
public:
    float phasing_rate;
    float prephasing_rate ;
    std::vector<int> restarts;

public:
    PhasingModel(float phasingrate = 0., float prephasingrate = 0.);
    PhasingModel(float phasingrate, float prephasingrate, std::vector<int> new_runs);
    std::vector<PhasingWindow> getPhasingCorrection(int cycle, int ncycles, 
                                                    int *is_deblocked);
};


void getPhasingMatrix(float *matrix, int ncycles, std::vector<int> restarts,
                      float phasingrate, float prephasingrate = 0.);
void definePhasingSubMatrix(float *matrix, int mx_dim,
                            int smx_dim_start, int smx_dim_end,
                            float phasingrate, float prephasingrate);
void getPhasingInvWindow(float *matrix, int ncycles, int cycle, float *window);


#endif /* _PHASINGMODEL_H */
