/*
 *
 * Copyright (c) 2005-2007 Solexa
 * Author: Klaus Maisinger
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 *
 */

//
// CVS - $Id: ProcessBaseCall.h,v 1.3 2007/02/26 12:33:53 km Exp $
//

#ifndef _PROCESSBASECALL_H_
#define _PROCESSBASECALL_H_


#include <vector>


#include "PhasingModel.h"

class ProcessBaseCall
{
    int ncycles;
    PhasingModel phasing;

public:
    ProcessBaseCall(int ncycles_ = 0);
    virtual ~ProcessBaseCall();
    void setPhasingModel(PhasingModel phasing_m);
    void setCycleNumber(int ncyc) { ncycles = ncyc; }
    void call(std::vector<float * > intensities,
              std::vector<float * > noise,
              std::vector<float * > matrices,
              int nobj, int ncol, int cycle,
              unsigned char *bases, int *is_deblocked,
              unsigned char *sequence, float *probabilities,
              float *signal, float *matrix_signal);
   void applyPhasingCorrection(std::vector<float * > intensities,
                                std::vector<float * > noise,
                                std::vector<float * > matrices,
                                int nobj, int ncol, int cycle, int *is_deblocked,
                                float *res_signal, float *corr_signal, 
                                float *probabilities);
};


#endif //_PROCESSBASECALL_H_
