/*
 * Copyright (c) Solexa 2004, 2006
 * Author:
 * Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */
//---------------------------------------------------------------------------

#ifndef _FFTH
#define _FFTH

float *new_fourier_array(int nx, int ny);
void copy_fourier_array(float *src, float *dest, int nx, int ny);
void delete_fourier_array(float *a);
void fft_2d_r2c(float *in, float *out, int nx, int ny);
void fft_2d_c2r(float *in, float *out, int nx, int ny);
void correlate_fft_images(float *image1, float *image2, int nx, int ny,
                          float *correlation);
void correlate_images(float *image1, float *image2, int nx, int ny,
                      float *correlation);
void apply_fft_mask(float *in, float *out, float *mask, int nx, int ny);
void multiply_fft_fft(float *fft1, float *fft2, float *result, int nx, int ny);
void filter_fft_mask(float *real, float *out, float *mask, int nx, int ny);
int get_optimal_fft_length(int n);
void convert_fft2realimag(float *fft, int nx, int ny, 
                          float *real, float *imag, int halfplane = 0);
void convert_realimag2fft(float *real, float *imag, int nx, int ny,
                          float *fft);

#endif /* _FFTH */
