/*
 * Copyright (c) Solexa 2006
 * Author:
 * Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */
#ifndef INTENSITYDATA_H_
#define INTENSITYDATA_H_

#include <vector>
#include "ImageUtil.h"
#include "Tiling.h"

int write_index_positions(const char filename[],
						  int lane, int tile,
						  st_fposition *positions, int nobj);
int write_signal_array(const char filename[],
                       float *array, int nobj, int nall, int ncol = 4,
                       int lane = 0, int tile = 0,
                       st_fposition *positions = 0, int append_flag = 0);
int write_signal_array(const char filename[], std::vector<float * > signal,
                       int nobj, int ncol,
                       int lane = 0, int tile = 0, st_fposition *positions = 0);
int read_signal_array(const char filename[],
                      float *signal, int *nobj, int *ncol, int skipcols = 0);
void collect_signal_data(Tiling *name, filename_type type,   
                         int nobj, int tile_idx, int ncycles, int ncolours,
                         st_fposition *positions);
std::vector<float * > read_signal_array(const char *filename, 
                                        int *nobj, int *ncol, int *error,
                                        int offset = 4);

#endif /*INTENSITYDATA_H_*/
