
/*
 *
 * Copyright (c) 2006-2007 Solexa
 * Author: Lorenzo Milazzo
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 *
 */

//
// CVS - $Id: sorting_standard.cpp,v 1.1 2007/01/30 09:50:14 lm Exp $
//



#include "sorting_standard.h"


//
// sorting the data by using the 'Quicksort' algorithm developed by C.A.R. Hoare
//
void standardSorting(float *data, int left, int right)
{
    int i, j;
    float mean, temp;

    i = left;
    j = right;
    mean = data[(left + right) / 2];

    do {
        while (data[i] < mean && i < right)
            i++;
        while (mean < data[j] && j > left)
            j--;

        if (i <= j) {
            temp = data[i];
            data[i] = data[j];
            data[j] = temp;
            i++;
            j--;
        }
    } while (i <= j);

    if (left < j)
        standardSorting(data, left, j);
    if (i < right)
        standardSorting(data, i, right);


}
