/*  Time-stamp: <26 Jun 2006 17:03 BST QCRemapping.h km> */
/*
 * Copyright (c) Solexa 2005, 2006
 * Author: Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */
#ifndef _QCREMAPPING_H
#define _QCREMAPPING_H

#include <stdlib.h>
#include "ProcessAlign.h"

class OffsetTracker
{
    float *xsum, *ysum, *xsum2, *ysum2;
    int *count;
    int ntiles, ncolours;
public:
    OffsetTracker(int ntiles=1, int ncolours=4);
    ~OffsetTracker();
    void save(const char filename[], int index);
    void display(AlignmentTransform *default_transforms);
    void add_offsets(AlignmentTransform *transforms, int nc = 4, int tile = 0);
    void get_average_offsets(float *xoff, float *yoff, int tile = -1, 
                             int nc = -1, 
                             float *xsdev = NULL, float *ysdev = NULL);
    int get_count(int tile = -1);
};

int validate_object_counts(int *counts, int ncolour, int nmin = 10);
int validate_offsets(AlignmentTransform *position_transforms,
                     int colourmax, float max_offset,
                     AlignmentTransform *default_transforms,
                     int valid_counts = 255);
#endif /* _QCREMAPPING_H */
