/*
 * Copyright (c) Solexa 2006
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */
#ifndef XMLCONTENTHANDLER_H_
#define XMLCONTENTHANDLER_H_

#if defined(__BORLANDC__)
#include <stdio.h>
#else
#include <cstdio>
#endif
#include <string>

class XMLContentHandler
{
public:
    XMLContentHandler() {};
    virtual ~XMLContentHandler() {};
    virtual void startDocument() {};
    virtual void endDocument() {};
    virtual void startElement(const char name[]) {};
    virtual void endElement(const char name[]) {};
    virtual void characters(const char ch[], int start, int length) {};
    virtual void ignorableWhitespace(const char ch[], int start, int length) {};
};

class XMLFileWriter : public XMLContentHandler
{
    char *iws;
protected:
    FILE *fp;
    virtual void writeWhitespace();
    char *iobuffer;
    int iobuffer_len;
    int iobuffer_ptr;
    virtual void output(const char ch[]);
    virtual void flush();
public:
    XMLFileWriter();
    XMLFileWriter(FILE *filehandle);
    virtual ~XMLFileWriter();
    virtual void setFileHandle(FILE *filehandle);
    virtual void startDocument() {};
    virtual void endDocument() {};
    virtual void startElement(const char name[]);
    virtual void endElement(const char name[]);
    virtual void characters(const char ch[], int start, int length);
    virtual void ignorableWhitespace(const char ch[], int start, int length);
};

#endif /*XMLCONTENTHANDLER_H_*/
