package Gerald::Common;
use Exporter;
@ISA=("Exporter");
@EXPORT=qw(&getShortRunFolderName);

# PROJECT: GERALD
# MODULE:  Common.pm
# AUTHOR:  A. J. Cox
#
# Copyright (c) 2007 Solexa
# This source file is covered by the "Solexa Public Source License"
# agreement and bound by the terms therein.

# Functions common to the GERALD module
use warnings;
use strict;

{
    my $cvs_id='@(#) $Id: Common.pm,v 1.2 2007/02/22 09:47:20 tc Exp $';
    my $cvs_version='$Revision: 1.2 $';
    # Make CVS tag into a displayable string
#    $version=$cvs_version;
#    $version=~s/\$//g;
#    $version=~s/Revision//;
#    $id=$cvs_id;
#    $id=~s/\$//g;
} #scope


sub getShortRunFolderName
{
    my ($longRunFolderName)=@_;
    return "s" unless defined($longRunFolderName);
    $longRunFolderName=~s/^\d{6}_//; # strip date
    $longRunFolderName=~s/^slxa-//; # strip unnecessary machine name
    $longRunFolderName=~s/_0+/_/; # strip leading zeroes
    $longRunFolderName=~s/_[Ff][Cc]\d+$//; # remove any _FCxxxx idiocy at end
    return $longRunFolderName;
} # sub getShortRunFolderName


1;




